import {SampleJoke} from "../../model/SampleJoke";
import { setJokeById} from "../actions/SampleAction";
import {CustomJoke} from "../../model/CustomJoke";
import {setCustomJokeById} from "../actions/CustomJoke";

export const getItem = <TItem>(uri:string, constructor : (json:any) => TItem, setItem: (item: TItem) => any) => {
    //In order to use await your callback must be asynchronous using async keyword.
    return async dispatch => {
        //Then perform your asynchronous operations.
        try {
            const promise = await fetch(uri);
            //Then use the json method to get json data from api/
            const Json = await promise.json();
            const Item: TItem = constructor(Json);
            dispatch(setItem(Item));
        } catch (error) {
            console.log('Error---------', error);
        }
    }
}
export const getJokeById = (id) => {
    return getItem<SampleJoke>('https://iut-weather-api.azurewebsites.net/jokes/samples/' + id , (elt) => new SampleJoke(elt["id"], elt["type"], elt["setup"], elt["image"]), (item) => setJokeById(item))
}

export const getCustomJokeById = (id) => {
    return getItem<CustomJoke>('https://iut-weather-api.azurewebsites.net/jokes/' + id , (elt) => new CustomJoke(elt["id"], elt["type"], elt["setup"], elt["image"]), (item) => setCustomJokeById(item))
}